function [p, u] = invariant_moments(image)


[r c] = size(image);
x = ones(r,1)*(1:c);
y = (1:r)'*ones(1,c);

x = x(:) - c/2 - 0.5;
y = y(:) - r/2 - 0.5;
y = -y;
image = image(:);

m00 = sum(image);
m10 = sum(image.*x);
m01 = sum(image.*y);

xbar = m10/m00;
ybar = m01/m00;

u00 = m00;
x = x-xbar;
y = y-ybar;

u20 = sum(image.*(x.^2));
u02 = sum(image.*(y.^2));
u11 = sum(image.*x.*y);
u30 = sum(image.*(x.^3));
u03 = sum(image.*(y.^3));
u12 = sum(image.*x.*(y.^2));
u21 = sum(image.*y.*(x.^2));

norm = (u00)^2;
n02 = u02/norm;
n11 = u11/norm;
n20 = u20/norm;
norm = (u00)^2.5;
n03 = u03/norm;
n12 = u12/norm;
n21 = u21/norm;
n30 = u30/norm;

u = [ u00 u02 u11 u20 u03 u12 u21 u30 ];

p1 = n20 + n02;
p2 = (n20-n02)^2+4*n11^2;
p3 = (n30-3*n12)^2+(3*n21-n03)^2;
p4 = (n30+n12)^2+(n21+n03)^2;

p5 = (n30-3*n12)^2*(n30+n12)*((n30+n12)^2-3*(n21+n03)^2)+(n03-3*n21)*(n21+n03)*((n21+n03)^2-3*(n30+n12)^2);
p6 = (n20-n02)*((n30+n12)^2-(n21+n03)^2)+4*n11*(n30+n12)*(n21+n03);
p7 = (3*n21-n03)*(n30+n12)*((n30+n12)^2-3*(n21+n03)^2)+(3*n12-n30)*(n21+n03)*(3*(n30+n12)^2-(n21+n03)^2);

p = [p1 p2 p3 p4 p5 p6 p7];
